BEGIN
{
	print "fm2dxf v0.1 - par Olivier Remaud - http://www.foilivier.net\n";
	print "Foilmaker VRML to DXF converter\n";
	print "This program is FREE to use\n";
}

$header  = "  0\nSECTION\n  2\nHEADER\n  9\n\$ACADVER\n  1\nAC1014\n  9\n\$ACADMAINTVER\n 70\n     0\n  9\n\$DWGCODEPAGE\n  3\nDOS850\n  9\n\$INSBASE\n 10\n0.0\n 20\n0.0\n 30\n0.0\n  9\n\$EXTMIN\n 10\n1.000000E+20\n 20\n1.000000E+20\n 30\n1.000000E+20\n  9\n\$EXTMAX\n 10\n-1.000000E+20\n 20\n-1.000000E+20\n 30\n-1.000000E+20\n  9\n\$LIMMIN\n 10\n0.0\n 20\n0.0\n  9\n\$LIMMAX\n 10\n0.0\n 20\n0.0\n  9\n\$ORTHOMODE\n 70\n     0\n  9\n\$REGENMODE\n 70\n     1\n  9\n\$FILLMODE\n 70\n     1\n  9\n\$QTEXTMODE\n 70\n     0\n  9\n\$MIRRTEXT\n 70\n     1\n  9\n\$DRAGMODE\n 70\n     2\n  9\n\$LTSCALE\n 40\n1.0\n  9\n\$OSMODE\n 70\n     0\n  9\n\$ATTMODE\n 70\n     1\n  9\n\$TEXTSIZE\n 40\n0.2\n  9\n\$TRACEWID\n 40\n0.05\n  9\n\$TEXTSTYLE\n  7\nSTANDARD\n  9\n\$CLAYER\n  8\nPROFILE\n  9\n\$CELTYPE\n  6\nCONTINUOUS\n  9\n\$CECOLOR\n 62\n   256\n  9\n\$CELTSCALE\n 40\n1.0\n  9\n\$DELOBJ\n 70\n     1\n  9\n\$DISPSILH\n 70\n     0\n  9\n\$DIMSCALE\n 40\n1.0\n  9\n\$DIMASZ\n 40\n0.18\n  9\n\$DIMEXO\n 40\n0.0625\n  9\n\$DIMDLI\n 40\n0.38\n  9\n\$DIMRND\n 40\n0.0\n  9\n\$DIMDLE\n 40\n0.0\n  9\n\$DIMEXE\n 40\n0.18\n  9\n\$DIMTP\n 40\n0.0\n  9\n\$DIMTM\n 40\n0.0\n  9\n\$DIMTXT\n 40\n0.18\n  9\n\$DIMCEN\n 40\n0.09\n  9\n\$DIMTSZ\n 40\n0.0\n  9\n\$DIMTOL\n 70\n     0\n  9\n\$DIMLIM\n 70\n     0\n  9\n\$DIMTIH\n 70\n     1\n  9\n\$DIMTOH\n 70\n     1\n  9\n\$DIMSE1\n 70\n     0\n  9\n\$DIMSE2\n 70\n     0\n  9\n\$DIMTAD\n 70\n     0\n  9\n\$DIMZIN\n 70\n     0\n  9\n\$DIMBLK\n  1\n\n  9\n\$DIMASO\n 70\n     1\n  9\n\$DIMSHO\n 70\n     1\n  9\n\$DIMPOST\n  1\n\n  9\n\$DIMAPOST\n  1\n\n  9\n\$DIMALT\n 70\n     0\n  9\n\$DIMALTD\n 70\n     2\n  9\n\$DIMALTF\n 40\n25.4\n  9\n\$DIMLFAC\n 40\n1.0\n  9\n\$DIMTOFL\n 70\n     0\n  9\n\$DIMTVP\n 40\n0.0\n  9\n\$DIMTIX\n 70\n     0\n  9\n\$DIMSOXD\n 70\n     0\n  9\n\$DIMSAH\n 70\n     0\n  9\n\$DIMBLK1\n  1\n\n  9\n\$DIMBLK2\n  1\n\n  9\n\$DIMSTYLE\n  2\nSTANDARD\n  9\n\$DIMCLRD\n 70\n     0\n  9\n\$DIMCLRE\n 70\n     0\n  9\n\$DIMCLRT\n 70\n     0\n  9\n\$DIMTFAC\n 40\n1.0\n  9\n\$DIMGAP\n 40\n0.06\n  9\n\$DIMJUST\n 70\n     0\n  9\n\$DIMSD1\n 70\n     0\n  9\n\$DIMSD2\n 70\n     0\n  9\n\$DIMTOLJ\n 70\n     1\n  9\n\$DIMTZIN\n 70\n     0\n  9\n\$DIMALTZ\n 70\n     0\n  9\n\$DIMALTTZ\n 70\n     0\n  9\n\$DIMFIT\n 70\n     3\n  9\n\$DIMUPT\n 70\n     0\n  9\n\$DIMUNIT\n 70\n     2\n  9\n\$DIMDEC\n 70\n     4\n  9\n\$DIMTDEC\n 70\n     4\n  9\n\$DIMALTU\n 70\n     2\n  9\n\$DIMALTTD\n 70\n     2\n  9\n\$DIMTXSTY\n  7\nSTANDARD\n  9\n\$DIMAUNIT\n 70\n     0\n  9\n\$LUNITS\n 70\n     2\n  9\n\$LUPREC\n 70\n     4\n  9\n\$SKETCHINC\n 40\n0.1\n  9\n\$FILLETRAD\n 40\n0.0\n  9\n\$AUNITS\n 70\n     0\n  9\n\$AUPREC\n 70\n     0\n  9\n\$MENU\n  1\nacad\n  9\n\$ELEVATION\n 40\n0.0\n  9\n\$PELEVATION\n 40\n0.0\n  9\n\$THICKNESS\n 40\n0.0\n  9\n\$LIMCHECK\n 70\n     0\n  9\n\$BLIPMODE\n 70\n     1\n  9\n\$CHAMFERA\n 40\n0.0\n  9\n\$CHAMFERB\n 40\n0.0\n  9\n\$CHAMFERC\n 40\n0.0\n  9\n\$CHAMFERD\n 40\n0.0\n  9\n\$SKPOLY\n 70\n     0\n  9\n\$TDCREATE\n 40\n0.000000000\n  9\n\$TDUPDATE\n 40\n0.000000000\n  9\n\$TDINDWG\n 40\n0.0000000000\n  9\n\$TDUSRTIMER\n 40\n0.0000000000\n  9\n\$USRTIMER\n 70\n     1\n  9\n\$ANGBASE\n 50\n0.0\n  9\n\$ANGDIR\n 70\n     0\n  9\n\$PDMODE\n 70\n     0\n  9\n\$PDSIZE\n 40\n0.0\n  9\n\$PLINEWID\n 40\n0.0\n  9\n\$COORDS\n 70\n     0\n  9\n\$SPLFRAME\n 70\n     0\n  9\n\$SPLINETYPE\n 70\n     6\n  9\n\$SPLINESEGS\n 70\n     8\n  9\n\$ATTDIA\n 70\n     0\n  9\n\$ATTREQ\n 70\n     1\n  9\n\$HANDLING\n 70\n     1\n  9\n\$HANDSEED\n  5\n";
$header2 = "\n  9\n\$SURFTAB1\n 70\n     6\n  9\n\$SURFTAB2\n 70\n     6\n  9\n\$SURFTYPE\n 70\n     6\n  9\n\$SURFU\n 70\n     6\n  9\n\$SURFV\n 70\n     6\n  9\n\$UCSNAME\n  2\n\n  9\n\$UCSORG\n 10\n0.0\n 20\n0.0\n 30\n0.0\n  9\n\$UCSXDIR\n 10\n1.0\n 20\n0.0\n 30\n0.0\n  9\n\$UCSYDIR\n 10\n0.0\n 20\n1.0\n 30\n0.0\n  9\n\$PUCSNAME\n  2\n\n  9\n\$PUCSORG\n 10\n0.0\n 20\n0.0\n 30\n0.0\n  9\n\$PUCSXDIR\n 10\n1.0\n 20\n0.0\n 30\n0.0\n  9\n\$PUCSYDIR\n 10\n0.0\n 20\n1.0\n 30\n0.0\n  9\n\$USERI1\n 70\n     0\n  9\n\$USERI2\n 70\n     0\n  9\n\$USERI3\n 70\n     0\n  9\n\$USERI4\n 70\n     0\n  9\n\$USERI5\n 70\n     0\n  9\n\$USERR1\n 40\n0.0\n  9\n\$USERR2\n 40\n0.0\n  9\n\$USERR3\n 40\n0.0\n  9\n\$USERR4\n 40\n0.0\n  9\n\$USERR5\n 40\n0.0\n  9\n\$WORLDVIEW\n 70\n     1\n  9\n\$SHADEDGE\n 70\n     3\n  9\n\$SHADEDIF\n 70\n    70\n  9\n\$TILEMODE\n 70\n     1\n  9\n\$MAXACTVP\n 70\n    16\n  9\n\$PINSBASE\n 10\n0.0\n 20\n0.0\n 30\n0.0\n  9\n\$PLIMCHECK\n 70\n     0\n  9\n\$PEXTMIN\n 10\n1.000000E+20\n 20\n1.000000E+20\n 30\n1.000000E+20\n  9\n\$PEXTMAX\n 10\n-1.000000E+20\n 20\n-1.000000E+20\n 30\n-1.000000E+20\n  9\n\$PLIMMIN\n 10\n0.0\n 20\n0.0\n  9\n\$PLIMMAX\n 10\n12.0\n 20\n9.0\n  9\n\$UNITMODE\n 70\n     0\n  9\n\$VISRETAIN\n 70\n     0\n  9\n\$PLINEGEN\n 70\n     1\n  9\n\$PSLTSCALE\n 70\n     0\n  9\n\$TREEDEPTH\n 70\n  3020\n  9\n\$PICKSTYLE\n 70\n     1\n  9\n\$CMLSTYLE\n  2\nSTANDARD\n  9\n\$CMLJUST\n 70\n     0\n  9\n\$CMLSCALE\n 40\n1.0\n  9\n\$PROXYGRAPHICS\n 70\n     0\n  9\n\$MEASUREMENT\n 70\n     0\n  0\nENDSEC\n  0\nSECTION\n  2\nCLASSES\n  0\nCLASS\n  1\nLWPOLYLINE\n  2\nAcDbPolyline\n  3\n\"AutoCAD\"\n 90\n        0\n280\n     0\n281\n     1\n  0\nCLASS\n  1\nIMAGE\n  2\nAcDbRasterImage\n  3\nISM\n 90\n      127\n280\n     0\n281\n     1\n  0\nCLASS\n  1\nOLE2FRAME\n  2\nAcDbOle2Frame\n  3\n\"\"\n 90\n        0\n280\n     0\n281\n     1\n  0\nCLASS\n  1\nHATCH\n  2\nAcDbHatch\n  3\n\"ACAD_SEDONA\"\n 90\n        0\n280\n     0\n281\n     1\n  0\nCLASS\n  1\nDICTIONARYVAR\n  2\nAcDbDictionaryVar\n  3\n\"AutoCAD\"\n 90\n        0\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nRASTERVARIABLES\n  2\nAcDbRasterVariables\n  3\nISM\n 90\n        0\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nIMAGEDEF\n  2\nAcDbRasterImageDef\n  3\nISM\n 90\n        0\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nIMAGEDEF_REACTOR\n  2\nAcDbRasterImageDefReactor\n  3\nISM\n 90\n        1\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nIDBUFFER\n  2\nAcDbIdBuffer\n  3\n\"Acad\"\n 90\n        0\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nSPATIAL_FILTER\n  2\nAcDbSpatialFilter\n  3\n\"Acad\"\n 90\n        0\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nXRECORD\n  2\nAcDbXrecord\n  3\n\"<Built In>\"\n 90\n        0\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nSORTENTSTABLE\n  2\nAcDbSortentsTable\n  3\n\"AutoCAD\"\n 90\n        0\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nLAYER_INDEX\n  2\nAcDbLayerIndex\n  3\n\"Acad\"\n 90\n        0\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nSPATIAL_INDEX\n  2\nAcDbSpatialIndex\n  3\n\"Acad\"\n 90\n        0\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nOBJECT_PTR\n  2\nCAseDLPNTableRecord\n  3\n\"ASE-LPNTableRecord\"\n 90\n        1\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nLAYOUT\n  2\nAcDbLayout\n  3\n\"AutoCAD 2000\"\n 90\n        1\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nPLOTSETTINGS\n  2\nAcDbPlotSettings\n  3\n\"AutoCAD 2000\"\n 90\n        1\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nACDBDICTIONARYWDFLT\n  2\nAcDbDictionaryWithDefault\n  3\n\"AutoCAD 2000\"\n 90\n        1\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nACDBPLACEHOLDER\n  2\nAcDbPlaceHolder\n  3\n\"AutoCAD 2000\"\n 90\n        1\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nVBA_PROJECT\n  2\nAcDbVbaProject\n  3\n\"acadvba\"\n 90\n        1\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nWIPEOUT\n  2\nAcDbWipeout\n  3\nWipeOut|AutoCAD Express Tool|expresstools\@autodesk.com\n 90\n      127\n280\n     0\n281\n     1\n  0\nCLASS\n  1\nWIPEOUTVARIABLES\n  2\nAcDbWipeoutVariables\n  3\nWipeOut|AutoCAD Express Tool|expresstools\@autodesk.com\n 90\n        0\n280\n     0\n281\n     0\n  0\nCLASS\n  1\nRTEXT\n  2\nRText\n  3\nRText|AutoCAD Express Tool|expresstools\@autodesk.com\n 90\n        0\n280\n     0\n281\n     1\n  0\nCLASS\n  1\nARCALIGNEDTEXT\n  2\nAcDbArcAlignedText\n  3\nATEXT|AutoCAD Express Tool|expresstools\@autodesk.com\n 90\n        0\n280\n     0\n281\n     1\n  0\nENDSEC\n  0\nSECTION\n  2\nTABLES\n  0\nTABLE\n  2\nVPORT\n  5\n7\n100\nAcDbSymbolTable\n 70\n     1\n  0\nVPORT\n  5\n15\n100\nAcDbSymbolTableRecord\n100\nAcDbViewportTableRecord\n  2\n*ACTIVE\n 70\n     0\n 10\n0.0\n 20\n0.0\n 11\n1.0\n 21\n1.0\n 12\n6.591288\n 22\n4.579184\n 13\n0.0\n 23\n0.0\n 14\n1.0\n 24\n1.0\n 15\n0.0\n 25\n0.0\n 16\n0.0\n 26\n0.0\n 36\n1.0\n 17\n0.0\n 27\n0.0\n 37\n0.0\n 40\n9.158369\n 41\n0.688564\n 42\n50.0\n 43\n0.0\n 44\n0.0\n 50\n0.0\n 51\n0.0\n 71\n     0\n 72\n   100\n 73\n     1\n 74\n     1\n 75\n     0\n 76\n     0\n 77\n     0\n 78\n     0\n  0\nENDTAB\n  0\nTABLE\n  2\nLTYPE\n  5\n4\n100\nAcDbSymbolTable\n 70\n     3\n  0\nLTYPE\n  5\n11\n100\nAcDbSymbolTableRecord\n100\nAcDbLinetypeTableRecord\n  2\nBYBLOCK\n 70\n    64\n  3\n\n 72\n    65\n 73\n     0\n 40\n0.0\n  0\nLTYPE\n  5\n12\n100\nAcDbSymbolTableRecord\n100\nAcDbLinetypeTableRecord\n  2\nBYLAYER\n 70\n    64\n  3\n\n 72\n    65\n 73\n     0\n 40\n0.0\n  0\nLTYPE\n  5\n13\n100\nAcDbSymbolTableRecord\n100\nAcDbLinetypeTableRecord\n  2\nCONTINUOUS\n 70\n    64\n  3\nSolid line\n 72\n    65\n 73\n     0\n 40\n0.0\n  0\nENDTAB\n  0\nTABLE\n  2\nLAYER\n  5\n2\n100\nAcDbSymbolTable\n 70\n     2\n  0\nLAYER\n  5\n14\n100\nAcDbSymbolTableRecord\n100\nAcDbLayerTableRecord\n  2\n0\n 70\n     0\n 62\n     7\n  6\nCONTINUOUS\n  0\nLAYER\n  5\n1D\n100\nAcDbSymbolTableRecord\n100\nAcDbLayerTableRecord\n  2\nPROFILE\n 70\n     0\n 62\n     7\n  6\nCONTINUOUS\n  0\nENDTAB\n  0\nTABLE\n  2\nSTYLE\n  5\n3\n100\nAcDbSymbolTable\n 70\n     1\n  0\nSTYLE\n  5\n17\n100\nAcDbSymbolTableRecord\n100\nAcDbTextStyleTableRecord\n  2\nSTANDARD\n 70\n     0\n 40\n0.0\n 41\n1.0\n 50\n0.0\n 71\n     0\n 42\n0.0\n  3\ntxt\n  4\n\n  0\nENDTAB\n  0\nTABLE\n  2\nVIEW\n  5\n5\n100\nAcDbSymbolTable\n 70\n     0\n  0\nENDTAB\n  0\nTABLE\n  2\nUCS\n  5\n6\n100\nAcDbSymbolTable\n 70\n     0\n  0\nENDTAB\n  0\nTABLE\n  2\nAPPID\n  5\n8\n100\nAcDbSymbolTable\n 70\n     1\n  0\nAPPID\n  5\n16\n100\nAcDbSymbolTableRecord\n100\nAcDbRegAppTableRecord\n  2\nACAD\n 70\n     0\n  0\nENDTAB\n  0\nTABLE\n  2\nDIMSTYLE\n  5\n9\n100\nAcDbSymbolTable\n 70\n     1\n  0\nDIMSTYLE\n105\n18\n100\nAcDbSymbolTableRecord\n100\nAcDbDimStyleTableRecord\n  2\nSTANDARD\n 70\n     0\n  3\n\n  4\n\n  5\n\n  6\n\n  7\n\n 40\n1.0\n 41\n0.18\n 42\n0.0625\n 43\n0.38\n 44\n0.18\n 45\n0.0\n 46\n0.0\n 47\n0.0\n 48\n0.0\n 71\n     0\n 72\n     0\n 73\n     1\n 74\n     1\n 75\n     0\n 76\n     0\n 77\n     0\n 78\n     0\n140\n0.18\n141\n0.09\n142\n0.0\n143\n25.4\n144\n1.0\n145\n0.0\n146\n1.0\n147\n0.09\n170\n     0\n171\n     2\n172\n     0\n173\n     0\n174\n     0\n175\n     0\n176\n     0\n177\n     0\n178\n     0\n270\n     2\n271\n     4\n272\n     4\n273\n     2\n274\n     2\n275\n     0\n280\n     0\n281\n     0\n282\n     0\n283\n     1\n284\n     0\n285\n     0\n286\n     0\n287\n     0\n288\n     0\n340\n17\n  0\nENDTAB\n  0\nTABLE\n  2\nBLOCK_RECORD\n  5\n1\n100\nAcDbSymbolTable\n 70\n     0\n  0\nBLOCK_RECORD\n  5\nA\n100\nAcDbSymbolTableRecord\n100\nAcDbBlockTableRecord\n  2\n*MODEL_SPACE\n  0\nBLOCK_RECORD\n  5\nB\n100\nAcDbSymbolTableRecord\n100\nAcDbBlockTableRecord\n  2\n*PAPER_SPACE\n  0\nENDTAB\n  0\nENDSEC\n  0\nSECTION\n  2\nBLOCKS\n  0\nBLOCK\n  5\nD\n100\nAcDbEntity\n  8\n0\n100\nAcDbBlockBegin\n  2\n*MODEL_SPACE\n 70\n     0\n 10\n0.0\n 20\n0.0\n 30\n0.0\n  3\n*MODEL_SPACE\n  1\n\n  0\nENDBLK\n  5\nE\n100\nAcDbEntity\n  8\n0\n100\nAcDbBlockEnd\n  0\nBLOCK\n  5\nF\n100\nAcDbEntity\n 67\n     1\n  8\n0\n100\nAcDbBlockBegin\n  2\n*PAPER_SPACE\n 70\n     0\n 10\n0.0\n 20\n0.0\n 30\n0.0\n  3\n*PAPER_SPACE\n  1\n\n  0\nENDBLK\n  5\n10\n100\nAcDbEntity\n 67\n     1\n  8\n0\n100\nAcDbBlockEnd\n  0\nENDSEC\n  0\nSECTION\n  2\nENTITIES\n";
$footer  = "  0\nENDSEC\n  0\nSECTION\n  2\nOBJECTS\n  0\nDICTIONARY\n  5\n19\n100\nAcDbDictionary\n  3\nACAD_GROUP\n350\n1A\n  3\nACAD_MLINESTYLE\n350\n1B\n  0\nDICTIONARY\n  5\n1A\n102\n{ACAD_REACTORS\n330\n19\n102\n}\n100\nAcDbDictionary\n  0\nDICTIONARY\n  5\n1B\n102\n{ACAD_REACTORS\n330\n19\n102\n}\n100\nAcDbDictionary\n  3\nSTANDARD\n350\n1C\n  0\nMLINESTYLE\n  5\n1C\n102\n{ACAD_REACTORS\n330\n1B\n102\n}\n100\nAcDbMlineStyle\n  2\nSTANDARD\n 70\n     0\n  3\n\n 62\n     0\n 51\n90.0\n 52\n90.0\n 71\n     2\n 49\n0.5\n 62\n   256\n  6\nBYLAYER\n 49\n-0.5\n 62\n   256\n  6\nBYLAYER\n  0\nENDSEC\n  0\nEOF\n";

die ( "Nombre d'arguments incorrect !!\n=> Syntaxe : fm2dxf <fichier WRL FoilMaker> <fichier DXF> [-SPLINE]\n" )
	unless( @ARGV == 2 || @ARGV == 3 );

$fmwrlFile = $ARGV[0];
$dxfFile = $ARGV[1];

$spline = ( (@ARGV == 3) && (uc($ARGV[2]) eq "-SPLINE") );

die( "Impossible d'ouvrir le fichier WRL FoilMaker\n" )
	unless( open( IN, $fmwrlFile ));

die( "Impossible d'ouvrir le fichier DXF\n" )
	unless( open( OUT, ">$dxfFile" ));

print "Converting '$fmwrlFile' => '$dxfFile'\n";

$nbSplines = 0;
$nbLines = 0;
$nbPoints = 0;
$nbPolylines = 0;

@ventX1 = ();
@ventY1 = ();
@ventZ1 = ();

@ventX2 = ();
@ventY2 = ();
@ventZ2 = ();

@endsX = ();
@endsY = ();
@endsZ = ();

$n = 0x1F;
$entities = "";

## en-tte
$line = <IN>;
while( defined(IN) && $line !~ /coord *Coordinate/io )
{
	$line = <IN>;
}

## Ribs
@x = ();
@y = ();
@z = ();
undef($currentRib);
while( defined($line) && $line !~ /\# *Vent *coordinates/io )
{
	if ( $line =~ /\# Rib *([0-9]+)/io )
	{
		if ( defined($currentRib) )
		{
			$x[@x-1] = $x[0]+0.001;
			$y[@y-1] = $y[0]+0.001;
			$z[@z-1] = $z[0]+0.001;
			&writeRib();
			@x = (); @y = (); @z = ();
		}
		$currentRib = "RIB$1";
	}
	elsif( defined($currentRib) && $line =~ /^\s*([0-9\.\-]+) +([0-9\.\-]+) +([0-9\.\-]+)/io )
	{
		push( @x, $1 );
		push( @y, $2 );
		push( @z, $3 );
	}
	$line = <IN>;
}
&writeRib() if ( @x );
undef(@x); undef(@y); undef(@z);

for( $idx = 1; $idx < @endsX; $idx++ )
{
	$x1 = $endsX[$idx-1];
	$x2 = $endsX[$idx];
	$y1 = $endsY[$idx-1];
	$y2 = $endsY[$idx];
	$z1 = $endsZ[$idx-1];
	$z2 = $endsZ[$idx];
	&addLine( $x1, $y1, $z1, $x2, $y2, $z2, "TrailingEdge" );
}

## Vents
$first = 1;
while( defined($line) && $line !~ /\# *end *Coordinate/io )
{
	if( $line =~ /^\s*([0-9\.\-]+) +([0-9\.\-]+) +([0-9\.\-]+)/io )
	{
		$x = $1;
		$y = $2;
		$z = $3;
		if ( $first )
		{
			push( @ventX1, $x );
			push( @ventY1, $y );
			push( @ventZ1, $z );
			$first = 0;
		}
		else
		{
			push( @ventX2, $x );
			push( @ventY2, $y );
			push( @ventZ2, $z );
			$first = 1;
		}
	}
	$line = <IN>;
}

for( $idx = 1; $idx < @ventX1; $idx++ )
{
	$x1 = $ventX1[$idx-1];
	$x2 = $ventX1[$idx];
	$y1 = $ventY1[$idx-1];
	$y2 = $ventY1[$idx];
	$z1 = $ventZ1[$idx-1];
	$z2 = $ventZ1[$idx];
	&addLine( $x1, $y1, $z1, $x2, $y2, $z2, "Vents" );
}
for( $idx = 1; $idx < @ventX2; $idx++ )
{
	$x1 = $ventX2[$idx-1];
	$x2 = $ventX2[$idx];
	$y1 = $ventY2[$idx-1];
	$y2 = $ventY2[$idx];
	$z1 = $ventZ2[$idx-1];
	$z2 = $ventZ2[$idx];
	&addLine( $x1, $y1, $z1, $x2, $y2, $z2, "Vents" );
}

while( defined($line) && $line !~ /\# *Bridle/io )
{
	$line = <IN>;
}

while( defined($line) && $line !~ /\# *Primary *bridle *points *\(A,B,C,D,F,R\)/io )
{
	$line = <IN>;
}

while( defined($line) && $line !~ /\# *Secondary *bridle *points *\(FP,FS,RP,RS\)/io )
{
	if( $line =~ /^\s*([0-9\.\-]+),\s*([0-9\.\-]+),\s*([0-9\.\-]+),/io )
	{
		&addPoint( $1, $2, $3, "Bridle" );
	}
	$line = <IN>;
}

$first = 1;
while( defined($line) && $line !~ /\# *end *point/io )
{
	if( $line =~ /^\s*([0-9\.\-]+),\s*([0-9\.\-]+),\s*([0-9\.\-]+),/io )
	{
		&addPoint( $1, $2, $3, "Bridle" );
	}
	$line = <IN>;
}
close( IN );


print OUT $header;
print OUT uc(hex($n));
print OUT $header2;
print OUT $entities;
print OUT $footer;

close( OUT );

print " ... $nbPolylines polylines\n";
print " ... $nbSplines splines\n";
print " ... $nbLines lines\n";
print " ... $nbPoints points\n";
print "Conversion OK\n";

END
{
	close( IN );
	close( OUT );
}


###################################################################################################
###################################################################################################
###################################################################################################
###################################################################################################
###################################################################################################
###################################################################################################
###################################################################################################
###################################################################################################
###################################################################################################
###################################################################################################
###################################################################################################
###################################################################################################

sub addSpline
{
	my( $pX, $pY, $pZ, $layer ) = @_;
	$nb = scalar(@$pX);
	$entities .=
		
			"0\nSPLINE\n  5\n"
			. uc(hex($n))
			. "\n100\nAcDbEntity\n  8\n${layer}\n100\nAcDbSpline\n 70\n     11\n 71\n     3\n 72\n    $nb\n 73\n    $nb\n 42\n0.0000001\n 43\n0.0000001\n 44\n0.0000000001\n";
	
	
	for( $idx = 0; $idx < $nb; $idx++ )
	{
		$x = $$pX[$idx];
		$y = $$pY[$idx];
		$z = $$pZ[$idx];
		$entities .= " 10\n${x}\n 20\n${z}\n 30\n${y}\n";
	}
	for( $idx = 0; $idx < $nb; $idx++ )
	{
		$x = $$pX[$idx];
		$y = $$pY[$idx];
		$z = $$pZ[$idx];
		$entities .= " 11\n${x}\n 21\n${z}\n 31\n${y}\n";
	}
	$n++;
	$nbSplines++;
}

sub addPolyline
{
	my( $pX, $pY, $pZ, $layer ) = @_;
	$nb = scalar(@$pX);
	$entities .=
		
			"0\nPOLYLINE\n  5\n"
			. uc(hex($n++))
			. "\n100\nAcDbEntity\n  8\n${layer}\n100\nAcDb3dPolyline\n 66\n     1\n 10\n0.0\n 20\n0.0\n 30\n0.0\n 70\n   8\n";
	
	for( $idx = 0; $idx < $nb; $idx++ )
	{
		$x = $$pX[$idx];
		$y = $$pY[$idx];
		$z = $$pZ[$idx];
		$entities .= 
			"  0\nVERTEX\n  5\n"
			. uc(hex($n++))
			. "\n100\nAcDbEntity\n  8\n$layer\n100\nAcDbVertex\n100\nAcDb3dPolylineVertex\n 10\n${x}\n 20\n${z}\n 30\n${y}\n70\n   32\n" ;
	}
	$entities .=
		"  0\nSEQEND\n  5\n"
		. uc(hex($n++))
		. "\n100\nAcDbEntity\n  8\n$layer\n";

	$nbPolylines++;
}


sub addLine
{
	my( $x1, $y1, $z1, $x2, $y2, $z2, $layer ) = @_;
	$entities .= 
			
			"  0\nLINE\n  5\n"
			. uc(hex($n))
			. "\n100\nAcDbEntity\n  8\n${layer}\n100\nAcDbLine\n 10\n${x1}\n 20\n${z1}\n 30\n${y1}\n 11\n${x2}\n 21\n${z2}\n 31\n${y2}\n";
	$n++;
	$nbLines++;
}

sub addPoint
{
	my( $x, $y, $z, $layer ) = @_;
	$entities .= 
			
			"  0\nPOINT\n  5\n"
			. uc(hex($n))
			. "\n100\nAcDbEntity\n  8\n${layer}\n100\nAcDbPoint\n 10\n${x}\n 20\n${z}\n 30\n${y}\n";
	$n++;
	$nbPoints++;
}

sub writeRib
{
	if ( $spline )
	{
		&addSpline( \@x, \@y, \@z, "Ribs" );
	}
	else
	{
		&addPolyline( \@x, \@y, \@z, "Ribs" );
	}
	# Recherche plus grande X-Value (fin du profil)
	undef( $sIndex );
	for( $idx = 0; $idx < @x; $idx++ )
	{
		if ( !defined( $sIndex ) )
		{
			$sIndex = $idx;
			$sZValue = $z[$idx];
		}
		else
		{
			if ( $sZValue < $z[$idx] )
			{
				$sIndex = $idx;
				$sZValue = $z[$idx];
			}
		}
	}
	push( @endsX, $x[$sIndex] );
	push( @endsY, $y[$sIndex] );
	push( @endsZ, $z[$sIndex] );
}
